local spartan = LibStub("AceAddon-3.0"):GetAddon("SpartanUI");
local L = LibStub("AceLocale-3.0"):GetLocale("SpartanUI_Animated", true);
local AceConfig = LibStub("AceConfig-3.0");
local AceConfigDialog = LibStub("AceConfigDialog-3.0");
local addon = spartan:NewModule("Animation");

addon.optionsAnimation = {name = "Animation", type = "group", args = {}};

local t_power = { };
local lUnitExists = UnitExists
local lUnitPowerType = UnitPowerType
local s_table = { ["player"] = SUI_PlayerFrame, 
				  ["target"] = SUI_targetFrame,
				  ["pet"]	 = SUI_petFrame,
				  ["focus"]  = SUI_focusFrame,
				  ["targettarget"] = SUI_targettargetFrame,
				  ["focustarget"] = SUI_focustargetFrame,
}
--[[ --  default values for another time
DBdefault.Modules.Animation = {
			enable = true,
			animationInterval = 0,
			animationIntervalStop = 0.15,
			health = "interface\\addons\\SpartanUI_Animated\\Animations\\Health\\HealthBar",
			mana = "interface\\addons\\SpartanUI_Animated\\Animations\\Mana\\Manabar",
			cast = "interface\\addons\\SpartanUI_Animated\\Animations\\Cast\\CastBar",
			focus = "interface\\addons\\SpartanUI_Animated\\Animations\\Energy\\EnergyBar", 
			runicpower = "interface\\addons\\SpartanUI_Animated\\Animations\\Mana\\Manabar",
			energy = "interface\\addons\\SpartanUI_Animated\\Animations\\Energy\\EnergyBar",
			rage = "interface\\addons\\SpartanUI_Animated\\Animations\\Rage\\RageBar",
			} ]]
			
function addon:OnInitialize()
	local textures = {["interface\\addons\\SpartanUI_Animated\\Animations\\Health\\HealthBar"] = L["Bar/Health"],
					  ["interface\\addons\\SpartanUI_Animated\\Animations\\Cast\\CastBar"] = L["Bar/Casting"],
					  ["interface\\addons\\SpartanUI_Animated\\Animations\\Mana\\Manabar"] = L["Bar/Mana"],
					  ["interface\\addons\\SpartanUI_Animated\\Animations\\Rage\\RageBar"] = L["Bar/Rage"],
					  ["interface\\addons\\SpartanUI_Animated\\Animations\\Energy\\EnergyBar"] = L["Bar/Energy"]}
					  
	addon.optionsAnimation.args["enable"] = {name=L["Animation/Enabled"],type="toggle",order=1,width="full",disabled=true,
		get = function(info) return SDBMod.Animation.enable end,
		set = function(info,val) SDBMod.Animation.enable = val if val ~= true then return end end
	}
	addon.optionsAnimation.args["health"] = {name=L["BarTexture/Health"],type="select",order=5,
		style="dropdown",values=textures,
		get = function(info) return SDBMod.Animation.health or t_power[7] end,
		set = function(info,val) SDBMod.Animation.health = val; t_power[7] = val end
	}
	addon.optionsAnimation.args["cast"] = {name=L["BarTexture/Casting"],type="select",order=6,
		style="dropdown",values=textures,
		get = function(info) return SDBMod.Animation.cast or t_power[8]  end,
		set = function(info,val) SDBMod.Animation.cast = val; t_power[8] = val end
	}
	addon.optionsAnimation.args["mana"] = {name=L["BarTexture/Mana"],type="select",order=7,
		style="dropdown",values=textures,
		get = function(info) return SDBMod.Animation.mana or t_power[0] end,
		set = function(info,val) SDBMod.Animation.mana = val; t_power[0] = val end
	}
	addon.optionsAnimation.args["rage"] = {name=L["BarTexture/Rage"],type="select",order=8,
		style="dropdown",values=textures,
		get = function(info) return SDBMod.Animation.rage or t_power[1]  end,
		set = function(info,val) SDBMod.Animation.rage = val; t_power[1] = val end
	}
	addon.optionsAnimation.args["energy"] = {name=L["BarTexture/Energy"],type="select",order=9,
		style="dropdown",values=textures,
		get = function(info) return SDBMod.Animation.energy or t_power[3]  end,
		set = function(info,val) SDBMod.Animation.energy = val; t_power[3] = val end
	}
	addon.optionsAnimation.args["focus"] = {name=L["BarTexture/Focus"],type="select",order=10,
		style="dropdown",values=textures,
		get = function(info) return SDBMod.Animation.focus or t_power[4]  end,
		set = function(info,val) SDBMod.Animation.focus = val; t_power[4] = val end
	}
	addon.optionsAnimation.args["runicpower"] = {name=L["BarTexture/RunicPower"],type="select",order=11,
		style="dropdown",values=textures,
		get = function(info) return SDBMod.Animation.runicpower or t_power[6] end,
		set = function(info,val) SDBMod.Animation.runicpower = val; t_power[6] = val; t_power[5] = val end
	}
	addon.optionsAnimation.args["animationIntervalStop"] = {name=L["BarTexture/Speed"],type="range",order=12,width="double",
		min=0.01,max=0.3,step=0.01,
		get = function(info) return SDBMod.Animation.animationIntervalStop or 0.15 end,
		set = function(info,val) SDBMod.Animation.animationIntervalStop = val end
	}
end

function addon:OnEnable()
		f = CreateFrame("Frame", "Animation", WorldFrame);
		AceConfig:RegisterOptionsTable("Animation", addon.optionsAnimation)
		if spartan:GetModule("Animation", true) then AceConfigDialog:AddToBlizOptions("Animation", L["Animation"], "SpartanUI") end
		
		f:SetFrameStrata("BACKGROUND");
		f:RegisterEvent("PLAYER_ENTERING_WORLD");
		SUI_PlayerFrame.Castbar:SetStatusBarColor(1,1,1,1);	
		f:SetScript("OnEvent", function(self, event) addon:OnEvent(self, event) end);
		f:SetScript("OnUpdate", function(self, elapsed) addon:Update(self, elapsed) end);
end

function addon:OnEvent()
    if not (SDBMod) then SDBMod = { Animation = { animationInterval = 0, animationIntervalStop = 0.15 } } end
	t_power[0] = SDBMod.Animation.mana or "interface\\addons\\SpartanUI_Animated\\Animations\\Mana\\Manabar" --"mana",
	t_power[1] = SDBMod.Animation.rage or "interface\\addons\\SpartanUI_Animated\\Animations\\Rage\\RageBar" --"rage",
	t_power[2] = SDBMod.Animation.focus or "interface\\addons\\SpartanUI_Animated\\Animations\\Energy\\EnergyBar" --"focus", 
	t_power[3] = SDBMod.Animation.energy or t_power[2] --"energy", 
	t_power[4] = SDBMod.Animation.focus or t_power[2] --"happiness", 
	t_power[5] = SDBMod.Animation.runicpower or t_power[0] --"runes", 
	t_power[6] = SDBMod.Animation.runicpower or t_power[0] --"runic power" 
	t_power[7] = SDBMod.Animation.health or "interface\\addons\\SpartanUI_Animated\\Animations\\Health\\HealthBar"-- health unsused
	t_power[8] = SDBMod.Animation.cast or "interface\\addons\\SpartanUI_Animated\\Animations\\Cast\\CastBar"--castbar unused
end

local Sui_anime = function(self,power)	
	local frameCount = (self.frameCount or 0) % 40 + 1
	self.frameCount = frameCount
	self:SetStatusBarTexture(power..tostring(frameCount))	
	return
end

function addon:Update(self,elapsed)
	SDBMod.Animation.animationInterval = SDBMod.Animation.animationInterval + elapsed;	
	while ( SDBMod.Animation.animationInterval > SDBMod.Animation.animationIntervalStop ) do
		for unit,frame in pairs(s_table) do
			if lUnitExists(unit) and frame:IsVisible() then
				local power = (lUnitPowerType(unit) or 0) % 7
				Sui_anime(frame.Health, t_power[7]);
				Sui_anime(frame.Power,t_power[power]);
				if frame.Castbar and (frame.Castbar.casting or frame.Castbar.channeling) then
					Sui_anime(frame.Castbar, t_power[8]);
				end
			end
		end	
		SDBMod.Animation.animationInterval = SDBMod.Animation.animationInterval - SDBMod.Animation.animationIntervalStop;
	end
	return
end